//+-----------------------------------------------------------------------------+
//| Copyright (C) 2013 REGEO (http://www.regeo.uji.es/)
//|
//| This program is free software
//| You can redistribute it and/or modify it under the terms of the GNU General Public License,
//| as published by the Free Software Foundation.
//| 
//| This program is distributed in the hope that it will be useful,
//| but WITHOUT ANY WARRANTY; without even the implied warranty of
//| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//+----------------------------------------------------------------------------*/

#include "stdafx.h"
#include <math.h>

#include "CueFacesV_Geometry.h"


void Normalise (VECTOR3D *Vector)
{
	double X = Vector->x;
	double Y = Vector->y;
	double Z = Vector->z;
	double D = sqrt(X*X+Y*Y+Z*Z);
	Vector->x /= D;
	Vector->y /= D;
	Vector->z /= D;
}
//
//
//double VectorMagnitude (VECTOR3D *V)
//{
//	return sqrt(V->x*V->x + V->y*V->y + V->z*V->z);
//}
//
//
//void GetCrossProduct (VECTOR3D *CrossProduct, VECTOR3D *A, VECTOR3D *B)
//{
//	CrossProduct->x = (A->y*B->z) - (A->z*B->y);
//	CrossProduct->y = (A->z*B->x) - (A->x*B->z);
//	CrossProduct->z = (A->x*B->y) - (A->y*B->x);
//}


double DotProduct (VECTOR3D *Vector1, VECTOR3D *Vector2)
{
	return (Vector1->x*Vector2->x) + (Vector1->y*Vector2->y) + (Vector1->z*Vector2->z);
}


/* -------------------------------------------------------------------------------- */
//#define ONE_O_CLOCK     (30)
//#define TWO_O_CLOCK     (60)
//#define THREE_O_CLOCK   (90)
//#define FOUR_O_CLOCK   (120)
//#define FIVE_O_CLOCK   (150)
//#define SIX_O_CLOCK    (180)
//#define SEVEN_O_CLOCK  (210)
//#define EIGHT_O_CLOCK  (240)
//#define NINE_O_CLOCK   (270)
//#define TEN_O_CLOCK    (300)
//#define ELEVEN_O_CLOCK (330)
//#define TWELVE_O_CLOCK   (0)


DEGREES dangleclock (DEGREES Direction1, DEGREES Direction2)
/* -------------------------------------------------------------------------------- */
/* dangleclock returns the absolute value (in degrees) of the smaller angle between */
/* two lines on a clock face                                                        */
/* e.g. dangleclock (TWELVE_O_CLOCK, ONE_O_CLOCK)     is  30 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, TWO_O_CLOCK)     is  60 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, THREE_O_CLOCK)   is  90 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, FOUR_O_CLOCK)    is 120 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, FIVE_O_CLOCK)    is 150 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, SIX_O_CLOCK)     is 180 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, SEVEN_O_CLOCK)   is 150 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, EIGHT_O_CLOCK)   is 120 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, NINE_O_CLOCK)    is  90 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, TEN_O_CLOCK)     is  60 degrees                */
/* e.g. dangleclock (TWELVE_O_CLOCK, ELEVEN_O_CLOCK)  is  30 degrees                */
{
	DEGREES dD = Direction1 - Direction2;
	while (dD < 0.0)     dD += 360.0;
	while (dD >= 360.0)  dD -= 360.0;
	return (dD <= 180.0) ? dD : 360.0-dD;
}


DEGREES danglecwise (DEGREES Direction1, DEGREES Direction2)
/* -------------------------------------------------------------------------------- */
/* danglecwise returns the value (in degrees) of the clockwise angle between        */
/* two lines on a clock face; it is always positive                                 */
/* e.g. danglecwise (SIX_O_CLOCK, ONE_O_CLOCK)     is 210 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, TWO_O_CLOCK)     is 240 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, THREE_O_CLOCK)   is 270 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, FOUR_O_CLOCK)    is 300 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, FIVE_O_CLOCK)    is 310 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, SIX_O_CLOCK)     is   0 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, SEVEN_O_CLOCK)   is  30 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, EIGHT_O_CLOCK)   is  60 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, NINE_O_CLOCK)    is  90 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, TEN_O_CLOCK)     is 120 degrees                */
/* e.g. danglecwise (SIX_O_CLOCK, ELEVEN_O_CLOCK)  is 150 degrees                */
{
	while (Direction2 < Direction1)  Direction2 += 360.0;
	return Direction2-Direction1;
}


bool clockwise (DEGREES A, DEGREES B)
/* -------------------------------------------------------------------------------- */
/* clockwise returns whether or not the second direction is within the 180-degree   */
/* arc generated by moving clockwise from the first direction                       */
/* e.g. clockwise (TWELVE_O_CLOCK, TWELVE_O_CLOCK)  is  unreliable                  */
/* e.g. clockwise (TWELVE_O_CLOCK, ONE_O_CLOCK)     is  TRUE                        */
/* e.g. clockwise (TWELVE_O_CLOCK, TWO_O_CLOCK)     is  TRUE                        */
/* e.g. clockwise (TWELVE_O_CLOCK, THREE_O_CLOCK)   is  TRUE                        */
/* e.g. clockwise (TWELVE_O_CLOCK, FOUR_O_CLOCK)    is  TRUE                        */
/* e.g. clockwise (TWELVE_O_CLOCK, FIVE_O_CLOCK)    is  TRUE                        */
/* e.g. clockwise (TWELVE_O_CLOCK, SIX_O_CLOCK)     is  unreliable                  */
/* e.g. clockwise (TWELVE_O_CLOCK, SEVEN_O_CLOCK)   is  FALSE                       */
/* e.g. clockwise (TWELVE_O_CLOCK, EIGHT_O_CLOCK)   is  FALSE                       */
/* e.g. clockwise (TWELVE_O_CLOCK, NINE_O_CLOCK)    is  FALSE                       */
/* e.g. clockwise (TWELVE_O_CLOCK, TEN_O_CLOCK)     is  FALSE                       */
/* e.g. clockwise (TWELVE_O_CLOCK, ELEVEN_O_CLOCK)  is  FALSE                       */
{
	DEGREES C = B-A;
	while (C < 0.0)     C += 360.0;
	while (C >= 360.0)  C -= 360.0;
	return C < 180.0;
}
